//lcd.c
#include <string.h>
#include "lcd.h"


unsigned char data_high;
unsigned char data_low;
void Delay (unsigned long a) { while (--a!=0); }

unsigned short *pAdd_16   = (unsigned short*)LCD_BASE;
unsigned char *pAdd_8     = (unsigned char*)LCD_BASE;
unsigned char *pPulse     = (unsigned char*)LCD_BASE;


void E_Pulse(unsigned short data)
{
  pAdd_16 = (unsigned short*)LCD_BASE;  //refer pointer to specify address
  unsigned short temp;                  //temp variable

  temp = data & (~E_PULSE_BIT);         //pulse to 0
  *pAdd_16 = temp;
  Delay(10);

  temp = data | E_PULSE_BIT;            //pulse to 1
  *pAdd_16 = temp;
  Delay(10);

  temp = data & (~E_PULSE_BIT);         //pulse to 0
  *pAdd_16 = temp;
  Delay(10);
}


void Write(unsigned long Add, unsigned short uiData)
{
  //write
  pAdd_16 = (unsigned short*)(LCD_BASE+Add);
  *pAdd_16 = uiData;
}

void Write_E(unsigned long Add, unsigned short uiData, unsigned char RS)
{
  pAdd_16 = (unsigned short*)LCD_BASE;  //refer pointer to specify address
  unsigned short temp;                  //temp variable

  if(RS == 0)
  {
    temp = uiData & (~RS_BIT);
    *pAdd_16 = temp;
    E_Pulse(temp);
  }

  if(RS == 1)
  {
     temp = uiData | RS_BIT;
     *pAdd_16 = temp;
     E_Pulse(temp);
  }
}


void RS_to_1(unsigned short data)
{
  pAdd_16 = (unsigned short*)LCD_BASE;  //refer pointer to specify address
  unsigned short temp;                  //temp variable

  temp = data | RS_BIT;
  *pAdd_16 = temp;
}


void RS_to_0(unsigned short data)
{
  pAdd_16 = (unsigned short*)LCD_BASE;  //refer pointer to specify address
  unsigned short temp;                  //temp variable

  temp = data & (~RS_BIT);
  *pAdd_16 = temp;
}

void LCDInit()
{
  Write(0x0,0x0);               //set RS, RW, E port to 0
  Delay(100000);                //delay ~110ms


  Write_E(0x0, D4 | D5, 0);       //set D4, D5 -> to 1
  Delay(10000);                   //delay ~10ms

  Write_E(0x0, D4 | D5, 0);       //set D4, D5 -> to 1
  Delay(10000);                   //delay ~10ms

  Write_E(0x0, D4 | D5, 0);       //set D4, D5 -> to 1
  Delay(10000);                   //delay ~10ms

  Write_E(0x0, D5, 0);            //set D5 -> to 1
  Delay(10000);                   //delay ~10ms
}

void LCDSendCommand(unsigned short a)
{
  Write(0x0,0x0);               //set RS, RW, E port to 0
  Delay(5000);                 //delay for LCD char ~2ms

  data_high = 0x0;              //clear data
  data_low  = 0x0;              //clear data

  data_high = 0xf0 & a;         //get high 4 bits
  a = a<<4;                     //shift 4 bits left
  data_low  = 0xf0 & a;         //get high 4 bits

  Write_E(0x0, data_high, 0);
  Delay(5);

  Write_E(0x0, data_low, 0);
}

void LCDSendChar(unsigned short a)
{

  Write(0x0,0x0);               //set RS, RW, E port to 0
  Delay(5000);                 //delay for LCD char ~2ms

  data_high = 0x0;                //clear data
  data_low  = 0x0;                //clear data

  data_high = 0xf0 & a;           //get high 4 bits
  a = a<<4;                       //shift 4 bits left
  data_low  = 0xf0 & a;           //get high 4 bits

  Write_E(0x0, data_high, 1);
  Delay(5);

  Write_E(0x0, data_low, 1);

}

void LCDSendTxt(char* a)
{
  for(int i=0; i<strlen(a); i++)
  {
    LCDSendChar(a[i]);
  }
}

void SmartUp(void)
{
  for(int i=0; i<40; i++) LCDSendCommand(CUR_RIGHT);
}

void SmartDown(void)
{
  for(int i=0; i<40; i++) LCDSendCommand(CUR_LEFT);
}

void Light(unsigned char a)
{
  if(a == 0) Write(0x0, 0x0);
  if(a == 1) Write(0x0, LIGHT_BIT);
}

